-- Covert Operations Globals
-- Author: sman
-- DateCreated: 12/21/17 12:58:48 PM
--------------------------------------------------------------


MapModData.gT = MapModData.gT or {}
gT = MapModData.gT


-- =================================================================================================================================
--		Defined Constants / Misc. Tables

g_Starting_Game_Turn = Game.GetGameTurn()													-- Saves the initial game turn - in case this is a loaded save game		


g_bNotifyIfCovertOpPossible = true															-- Comment this line (add two dashes at the front) if you don't want Notifications


directions = {DirectionTypes.DIRECTION_NORTHEAST, DirectionTypes.DIRECTION_EAST, DirectionTypes.DIRECTION_SOUTHEAST,
              DirectionTypes.DIRECTION_SOUTHWEST, DirectionTypes.DIRECTION_WEST, DirectionTypes.DIRECTION_NORTHWEST}

INFEASIBLE = 4
PREVENTED = 3
ATWAR = 2
YES = 1
NO = 0
g_tMonths = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" }

ERA_ANCIENT_ID = GameInfoTypes.ERA_ANCIENT													-- Ancient Era type; careful: value is 0, don't use for table index!
ERA_CLASSICAL_ID = GameInfoTypes.ERA_CLASSICAL												-- Classical Era type
ERA_MEDIEVAL_ID = GameInfoTypes.ERA_MEDIEVAL												-- Medieval Era type
ERA_RENAISSANCE_ID = GameInfoTypes.ERA_RENAISSANCE											-- Renaissance Era type
ERA_INDUSTRIAL_ID = GameInfoTypes.ERA_INDUSTRIAL											-- Industrial Era type
ERA_MODERN_ID = GameInfoTypes.ERA_MODERN													-- Modern Era type
ERA_POSTMODERN_ID = GameInfoTypes.ERA_POSTMODERN											-- Atomic Era type
ERA_FUTURE_ID = GameInfoTypes.ERA_FUTURE													-- Info Era type

BARBARIAN_PLAYER = GameDefines.BARBARIAN_PLAYER

RESOURCE_URANIUM_ID = GameInfoTypes.RESOURCE_URANIUM

g_SpyRankIndexValue = {  TXT_KEY_SPY_RANK_0 = 1, TXT_KEY_SPY_RANK_1 = 2, TXT_KEY_SPY_RANK_2 = 3  };

g_iUnitInfluenceMultiplier = 3																-- How much each unit in city's borders improve defensive posture vs. Covert Ops 



-- Timing Variables - things that adjust frequency of COs
g_iGameSpeed = Game.GetGameSpeedType()														-- 0 = marathon, 1=epic, 2=std, 3=quick
g_iHandicap = Game:GetHandicapType()														-- 0 = settler, 1=chieftan, 2=warlord, 3=prince, 4=king, 5=emp, 6=immortal, 7 = deity		
if g_iHandicap < 1 then g_iHandicap = 1 end													-- Combine Settler & Chieftain into a single number

g_iAI_ChanceToLaunch = 10																	-- Percent chance for AI to launch a mission on any given turn
g_Open_Mission_Limit = 2																	-- Limit to how many open missions AI can have, regardless of chance to launch

g_iHuman_ChanceToLaunch = 10																-- Percent chance for human player to launch a mission on any given turn
g_bHumanAbleToLaunch = false																-- Global flag on whether the human player can launch a CO at this moment

g_Leader_Stats = {}																			-- Table holding verious information about the civ leaders in the game
COVERT_OPERATIONS_PROPENSITY = 1															-- g_Leader_Stats element [leader][1] - tracks COP
LOYALTY = 2																					-- g_Leader_Stats element [leader][2] - tracks loyalty value for leader

g_SelectedBuildingID = -2

-- =================================================================================================================================
--		Mission global data

CAPITAL_CITY = 1
CITY_STATE = 2
					
CONDUCT_RECON = 1
POISON_WATER = 2
SPREAD_RUMORS = 3
SABOTAGE_UNIT = 4
PILLAGE_IMPROVEMENT = 5
ASSASSINATE_GREAT_PERSON = 6
SABOTAGE_PRODUCTION = 7
STEAL_GOLD = 8
SPREAD_PLAGUE = 9
DESTROY_BUILDING = 10
RECRUIT_PARTISANS = 11
SPREAD_PROPAGANDA = 12
CAUSE_RESISTANCE = 13
CAUSE_ANARCHY = 14
NUKE_SUITCASE = 15
STEAL_CITY = 16
ABORT_MISSION = 17
ENABLE_NOTIFICATIONS = 98
MISSION_PREVENTED = 99


ML_MISSION_NAME = 1
ML_MISSION_SUCCESS = 2
ML_CHANCE_INCIDENT = 3
ML_MISSION_LEVEL = 4
ML_COST_FACTOR = 5
ML_MISSION_AVAILABLE_ERA = 6
ML_AI_CHANCE_TO_PICK = 7
ML_VALID_CAPITAL = 8
ML_VALID_CITYSTATE = 9
ML_NUM_ATTEMPTS = 10
ML_NUM_SUCCESS = 11
ML_NUM_PREVENTS = 12
ML_ENABLED = 13


--	Mission List Assumptions:  Recon is always mission #1, Abort is always last mission - DO NOT DISABLE THOSE TWO MISSIONS!
--	Mission IDX     =		Mission Name						Success		Incident	Level	Cost Factor		Available Era			AI Chance	Valid-Capital	Valid-CS	#Attempts	#Success	#Prevents	Enabled?

g_MissionList = {  
	[CONDUCT_RECON] = { "Conduct Reconnaisance",				90,			02,			1,		0.05,			ERA_CLASSICAL_ID,		0,			YES,			YES,		0,			0,			0,			YES		},	-- Level 1 Missions		
	[POISON_WATER] = { "Poison Wells",							55,			33,			1,		0.20,			ERA_CLASSICAL_ID,		7,			YES,			YES,		0,			0,			0,			YES		},	-- Changed to "Poison Wells" from "Poison Water" - sounds more appropriate to the Era (sman: 20180209)
	[SPREAD_RUMORS] = { "Spread Rumors",						45,			25,			1,		0.15,			ERA_CLASSICAL_ID,		12,			YES,			NO,			0,			0,			0,			YES		}, 
	[SABOTAGE_UNIT] = { "Sabotage Unit",						55,			33,			1,		0.25,			ERA_CLASSICAL_ID,		8,			YES,			YES,		0,			0,			0,			YES		}, 
	[PILLAGE_IMPROVEMENT] = { "Pillage Improvement",			55,			33,			1,		0.25,			ERA_MEDIEVAL_ID,		10,			YES,			YES,		0,			0,			0,			YES		},								
	
	[ASSASSINATE_GREAT_PERSON] = { "Assassinate Great Person",	40,			50,			2,		0.25,			ERA_MEDIEVAL_ID,		7,			YES,			NO,			0,			0,			0,			YES		},	-- Level 2 Missions							
	[SABOTAGE_PRODUCTION] = { "Sabotage Production",			55,			33,			2,		0.25,			ERA_MEDIEVAL_ID,		12,			YES,			YES,		0,			0,			0,			YES		},	
	[STEAL_GOLD] = { "Steal Gold",								55,			33,			2,		0.00,			ERA_RENAISSANCE_ID,		12,			YES,			NO,			0,			0,			0,			YES		},
	[SPREAD_PLAGUE] = { "Spread Plague",						55,			33,			2,		0.33,			ERA_RENAISSANCE_ID,		7,			YES,			YES,		0,			0,			0,			YES		},

	[DESTROY_BUILDING] = { "Destroy Building",					55,			33,			3,		0.25,			ERA_INDUSTRIAL_ID,		10,			YES,			YES,		0,			0,			0,			YES		},	-- Level 3 Missions
	[RECRUIT_PARTISANS] = { "Recruit Partisans",				45,			45,			3,		1.25,			ERA_INDUSTRIAL_ID,		5,			YES,			YES,		0,			0,			0,			YES		},
	[SPREAD_PROPAGANDA] = { "Spread Propaganda",				45,			25,			3,		0.33,			ERA_MODERN_ID,			12,			YES,			NO,			0,			0,			0,			YES		},		
					
	[CAUSE_RESISTANCE] = { "Cause Resistance",					45,			45,			4,		1.00,			ERA_POSTMODERN_ID,		5,			YES,			NO,			0,			0,			0,			YES		},	-- Level 4 Missions
	[CAUSE_ANARCHY] = { "Cause Anarchy",						45,			50,			4,		2.50,			ERA_POSTMODERN_ID,		5,			YES,			NO,			0,			0,			0,			YES		}, 

	[NUKE_SUITCASE] = { "Nuclear Suitcase",						40,			90,			5,		3.50,			ERA_POSTMODERN_ID,		3,			YES,			YES,		0,			0,			0,			YES		}, 	-- Level 5 Missions			
	[STEAL_CITY] = { "Steal City",								33,			75,			5,		5.00,			ERA_POSTMODERN_ID,		3,			NO,				NO,			0,			0,			0,			YES		}, 				
					
	[ABORT_MISSION] = { "Abort Mission",						100,		0,			0,		0.00,			ERA_ANCIENT_ID,			0,			YES,			YES,		0,			0,			0,			YES		},	-- Abort mission

	[ENABLE_NOTIFICATIONS] = { "Enable Notifications",					100,		0,			0,		0.00,			ERA_ANCIENT_ID,			0,			YES,			YES,		0,			0,			0,			YES		}  }	-- Dummy placeholder for the "Disable Notifications" 'mission...' 


gT.g_MissionList = g_MissionList


	
g_iActiveMission = ABORT_MISSION
g_NumMissions = #g_MissionList
g_iMinimumMissionAdjustment = 20															-- Lower floor of how low an adjusted percentage chance of mission success. Chance of success will never be below this amount
g_iMissionCost = 0																			-- Global that tracks the specific cost for the ActiveMission


g_sIncidentName = { [1]="Muted", [2]="Minor", [3]="Denounce", [4]="Denounce with Allies", [5]="War", [6]="War with Allies", [7]="Permanent War", [8]="Global War", [9]="No Response", [10]="Response Changed" }
g_IncidentStats = { [1]=0, [2]=0, [3]=0, [4]=0, [5]=0, [6]=0, [7]=0, [8]=0, [9]=0, [10]=0 }				-- Stats for Incidents


--g_Diplomacy_Adjustment = {}

-- =================================================================================================================================
--		Buildings Influence global data  - building constants are the building ID

BUILDING_BARRACKS = GameInfoTypes.BUILDING_BARRACKS											-- Training buildings: 1%
BUILDING_KREPOST = GameInfoTypes.BUILDING_KREPOST
BUILDING_ARMORY = GameInfoTypes.BUILDING_ARMORY												
BUILDING_MILITARY_ACADEMY = GameInfoTypes.BUILDING_MILITARY_ACADEMY
BUILDING_ARSENAL = GameInfoTypes.BUILDING_ARSENAL

BUILDING_WALLS = GameInfoTypes.BUILDING_WALLS												-- Defensive buildings: 2%
BUILDING_CASTLE = GameInfoTypes.BUILDING_CASTLE
BUILDING_MILITARY_BASE = GameInfoTypes.BUILDING_MILITARY_BASE
BUILDING_CONSTABLE = GameInfoTypes.BUILDING_CONSTABLE
BUILDING_POLICE_STATION = GameInfoTypes.BUILDING_POLICE_STATION

BUILDING_PALACE = GameInfoTypes.BUILDING_PALACE												-- Special buildings: varies
BUILDING_COURTHOUSE = GameInfoTypes.BUILDING_COURTHOUSE

BUILDING_MUGHAL_FORT = GameInfoTypes.BUILDING_MUGHAL_FORT									-- Wonders: varies
BUILDING_HEROIC_EPIC = GameInfoTypes.BUILDING_HEROIC_EPIC
BUILDING_HIMEJI_CASTLE = GameInfoTypes.BUILDING_HIMEJI_CASTLE
BUILDING_FORBIDDEN_PALACE = GameInfoTypes.BUILDING_FORBIDDEN_PALACE
BUILDING_WALLS_OF_BABYLON = GameInfoTypes.BUILDING_WALLS_OF_BABYLON
BUILDING_GREAT_WALL = GameInfoTypes.BUILDING_GREAT_WALL
BUILDING_INTELLIGENCE_AGENCY = GameInfoTypes.BUILDING_INTELLIGENCE_AGENCY
BUILDING_GREAT_FIREWALL = GameInfoTypes.BUILDING_GREAT_FIREWALL

BUILDING_BOMB_SHELTER = GameInfoTypes.BUILDING_BOMB_SHELTER


-- Table containing the Building ID [1], and the Adjustment [2] - adjustment is the % chance to impact mission; total is 50
g_tBuildingList = {	[1] = { BUILDING_BARRACKS, 1 }, [2] = { BUILDING_KREPOST, 1 }, [3] = { BUILDING_ARMORY, 1 }, [4] = { BUILDING_MILITARY_ACADEMY, 1 }, 
					[5] = { BUILDING_ARSENAL, 1 }, [6] = { BUILDING_WALLS, 2 }, [7] = { BUILDING_CASTLE, 2 }, [8] = { BUILDING_MILITARY_BASE, 2 }, 
					[9] = { BUILDING_CONSTABLE, 2 }, [10] = { BUILDING_POLICE_STATION, 3 },	[11] = { BUILDING_PALACE, 6 }, [12] = { BUILDING_COURTHOUSE, 2 }, 
					[13] = { BUILDING_MUGHAL_FORT, 5 }, [14] = { BUILDING_HEROIC_EPIC, 5 }, [15] = { BUILDING_HIMEJI_CASTLE, 4 }, [16] = { BUILDING_FORBIDDEN_PALACE, 2 }, 
					[17] = { BUILDING_WALLS_OF_BABYLON, 2 }, [18] = { BUILDING_GREAT_WALL, 2}, [19] = { BUILDING_INTELLIGENCE_AGENCY, 5 }, [20] = { BUILDING_GREAT_FIREWALL, 4 }  } 					
					
-- =================================================================================================================================
--		Rebel unit spawn data  - used to determine appropriate unit to spawn based on target civ's Era

--WARRIOR_ID = GameInfoTypes.UNIT_WARRIOR														-- Ancient "standard" infantry unit
--SWORDSMAN_ID = GameInfoTypes.SWORDSMAN														-- Classical unit
SPEARMAN_ID = GameInfoTypes.UNIT_SPEARMAN													-- Classical "standard" infantry unit
--LONGSWORDSMAN_ID = GameInfoTypes.UNIT_LONGSWORDSMAN											-- Medieval unit
PIKEMAN_ID = GameInfoTypes.UNIT_PIKEMAN														-- Medieval "standard" rebel unit
MUSKETMAN_ID = GameInfoTypes.UNIT_MUSKETMAN													-- Renaissance "standard" rebel unit
RIFLEMAN_ID = GameInfoTypes.UNIT_RIFLEMAN													-- Industrial "standard" rebel unit
WW1_INFANTRY_ID = GameInfoTypes.UNIT_GREAT_WAR_INFANTRY										-- Modern "standard" rebel unit
WW2_INFANTRY_ID = GameInfoTypes.UNIT_INFANTRY												-- Atomic "standard" rebel unit
MECHANIZED_INFANTRY_ID = GameInfoTypes.UNIT_MECHANIZED_INFANTRY								-- Information "standard" rebel unit

ATOMIC_BOMB_ID = GameInfoTypes.UNIT_ATOMIC_BOMB								

-- ERA_ANCIENT_ID value is 0 - dont use as table index, which is OK, as there are no CO missions set in the Ancient Era

tRebelInfantryUnits = { [ERA_CLASSICAL_ID] = SPEARMAN_ID,			[ERA_MEDIEVAL_ID] = PIKEMAN_ID,		[ERA_RENAISSANCE_ID] = MUSKETMAN_ID,
						[ERA_INDUSTRIAL_ID] = RIFLEMAN_ID,			[ERA_MODERN_ID] = WW1_INFANTRY_ID,	[ERA_POSTMODERN_ID] = WW2_INFANTRY_ID, 
						[ERA_FUTURE_ID] = MECHANIZED_INFANTRY_ID  }
