-- Covert Operations Globals
-- Author: sman
-- DateCreated: 02/05/18 07:51:38 AM
--------------------------------------------------------------

-- =================================================================================
--			Functions

function SetUpGlobals ()
	
	-- ========================================================================================================================
	-- Chance to Launch Covert Op: based on game difficulty and speed
	--		Handicap:  1=Chieftain, 2=Warlord, 3=Prince, 4=King, 5=Emperor, 6=Immortal, 7=Deity
	--		Game Speed: 0=Marathon, 1=Epic, 2=Standard, 3=Quick			
		
	g_iAI_ChanceToLaunch = 	(g_iHandicap * 5) + (g_iGameSpeed * 5) + 10						-- Deity/Quick = 50%, Imp/Epic=34%, King/Std=34%, Chief/Marathon=14%
	g_iHuman_ChanceToLaunch = (g_iHandicap * 5) + (g_iGameSpeed * 5)						-- Deity/Quick = 40%, Imp/Epic=24%, King/Std=24%, Chief/Marathon=4% (bumped later)
	
	if g_iAI_ChanceToLaunch < 10 then g_iAI_ChanceToLaunch = 10 end							-- Ensure at least a 10% chance for AI mission - tests added in case a different mod adds different eras/gamespeeds
	--if g_iAI_ChanceToLaunch > 50 then g_iAI_ChanceToLaunch = 50 end							-- Ensure max 50% chance for AI mission
	if g_iHuman_ChanceToLaunch < 10 then g_iHuman_ChanceToLaunch = 10 end					-- Ensure at least a 10% chance for human mission
	--if g_iHuman_ChanceToLaunch > 50 then g_iHuman_ChanceToLaunch = 50 end					-- Ensure max 50% chance for human mission

	-- TEMP ADJUSTMENT AREA	===================================================================================================
	--g_iHuman_ChanceToLaunch = 99															-- Reserved area where changes are made to force/test specific game mechanics
	--Players[0]:ChangeNumResourceTotal(RESOURCE_URANIUM_ID, 10)								-- Be sure to disable in final mod versions!

	--g_iAI_ChanceToLaunch = g_iAI_ChanceToLaunch  * 3
	--g_iHuman_ChanceToLaunch = g_iHuman_ChanceToLaunch * 1.5

	-- END OF TEMP PADJUSTMENT AREA	==========================================================================================

	--print("Human Chance to Launch: " .. g_iHuman_ChanceToLaunch .. "    AI Chance to Launch: " .. g_iAI_ChanceToLaunch)
		
	-- ========================================================================================================================
	-- AI Open Mission limit: based on game difficulty
	-- Deity=4, Immortal=4, Emperor=3, King=3, Prince=2, Warlord=2, Chieftain=1

	g_Open_Mission_Limit = math.floor( (g_iHandicap / 2 ) + 1 )								
	if g_Open_Mission_Limit > 5 then g_Open_Mission_Limit = 5 end							-- Add upper bound, in case another mod adds a new difficulty
	if g_Open_Mission_Limit < 1 then g_Open_Mission_Limit = 1 end							-- Add lower bound, in case another mod adds a new difficulty
	--print("AI Open Mission Limit: " .. g_Open_Mission_Limit)		
	
	-- ========================================================================================================================
	-- Set up diplomacy modifiers - used later to inject CO results into the in-game diplomacy system
	
	--for i = 0, GameDefines.MAX_PLAYERS-1,1 do
		--for j = 0, GameDefines.MAX_PLAYERS-1,1 do
		--	local pPlayer = Players[i]
		--	local pOtherPlayer = Players[j]
			
		--	if pPlayer and pOtherPlayer and pPlayer:IsEverAlive() and pOtherPlayer:IsEverAlive() and 
		--			not pPlayer:IsMinorCiv() and not pOtherPlayer:IsMinorCiv() and 
		--			not pPlayer:IsBarbarian() and not pOtherPlayer:IsBarbarian() then

		--		if g_Diplomacy_Adjustment[i] == nil then
		--			g_Diplomacy_Adjustment[i] = {}
		--		end
		--		g_Diplomacy_Adjustment[i][j] = 0
		--	end
		--end
  -- end

end
Events.SequenceGameInitComplete.Add( SetUpGlobals )


function PopulateLeaderStats()																-- Populate global table g_Leader_Stats at game start
	-- Add adjustments for leader stats: VictoryCompetitiveness, Boldness, Warmongerhate, Meanness; Major biases: MAJOR_CIV_APPROACH_WAR, MAJOR_CIV_APPROACH_AFRAID; Flavors: FLAVOR_ESPIONAGE, FLAVOR_OFFENSE, FLAVOR_DEFENSE
	--g_Starting_Game_Turn = Game.GetGameTurn()												-- Saves the initial game turn - in case this is a loaded save game; IOW: if the value isn't 0, then this is a loaded savegame		

	for iPlayer=1, GameDefines.MAX_MAJOR_CIVS-1 do											-- Cycle through all major (non-human) players - Get all civs, even ones no longer in the game (for savegames) - in case of resurrection		
		local iLeaderType = Players[iPlayer]:GetLeaderType()								-- Grab Leader data from 3 sources: Leader definition file, Leader_MajorCivApproachBiases, and Leader_Flavors
		local iCurrentEra = Players[iPlayer]:GetCurrentEra()
		local pLeaderInfo = GameInfo.Leaders[iLeaderType]
		local sLeaderName = GameInfo.Leaders[iLeaderType].Description or "unk"
		local iVicCompete = GameInfo.Leaders[iLeaderType].VictoryCompetitiveness or 3		-- The 3 or 5 used here is for a "safe" default, in case for some bizzarre reason we can't get a better number
		local iBoldness = GameInfo.Leaders[iLeaderType].Boldness or 3
		local iWarmongerHate = GameInfo.Leaders[iLeaderType].WarmongerHate or 3
		local iMeanness = GameInfo.Leaders[iLeaderType].Meanness or 3
		local iLoyalty = GameInfo.Leaders[iLeaderType].Loyalty or 3
		local iMajorWarApproach = 5
		local iMajorAfraidApproach = 5
		local iFlavorEspionage = 3
		local iFlavorOffense = 3
		local iFlavorDefense = 3

		for row in DB.Query("SELECT MajorCivApproachType, Bias FROM Leader_MajorCivApproachBiases WHERE LeaderType = '" .. pLeaderInfo.Type .."'" ) do	-- Get Major civ biases for this leader
			if row.MajorCivApproachType == "MAJOR_CIV_APPROACH_WAR" then
					iMajorWarApproach = row.Bias
			elseif row.MajorCivApproachType == "MAJOR_CIV_APPROACH_AFRAID" then
				iMajorAfraidApproach = row.Bias
			end			
		end
			
		for row in DB.Query("SELECT FlavorType, Flavor FROM Leader_Flavors WHERE LeaderType = '" .. pLeaderInfo.Type .."'" ) do		-- Get appropriate Flavors for this leader
			if row.FlavorType == "FLAVOR_ESPIONAGE" then
				iFlavorEspionage = row.Flavor
			elseif row.FlavorType == "FLAVOR_OFFENSE" then
				iFlavorOffense = row.Flavor
			elseif row.FlavorType == "FLAVOR_DEFENSE" then
				iFlavorDefense = row.Flavor
			end			
		end					
		
		-- the COVERT_OPERATIONS_PROPENSITY determines how aggressive this leader will use Covert Ops.  It adjusted based on the weighting for each variable
		local iCOP = math.floor(  ((iVicCompete * 2) + (iBoldness*2) + (iWarmongerHate*1) + (iMeanness*2) + (iMajorWarApproach*2) + (iFlavorEspionage*6) + (iFlavorOffense*3) -
									(iMajorAfraidApproach*3) - (iFlavorDefense*1)) * .33  )	 
										
		iCOP = iCOP + ( 25 - math.random(1, 50) )											-- Add +-25 to the iCOP - to provide some variability in leader behavior (sman:20180215)
		if iCOP < 1 then iCOP = 1 end

		g_Leader_Stats[iPlayer] = { [COVERT_OPERATIONS_PROPENSITY] = iCOP, [LOYALTY] = iLoyalty }	-- Set the COP value into the leader table
						
		if g_Starting_Game_Turn > 10 then													-- If initial game turn is over 10, then...  If so, then this is a loaded saved game - need to refresh the mission table
			Component1_Schedule_Mission(Players[iPlayer], g_Starting_Game_Turn, iCurrentEra)	-- Determine if iPlayer can schedule an attack planned for this game turn
		end
	end

	g_Leader_Stats[99] = { [COVERT_OPERATIONS_PROPENSITY] = 0, [LOYALTY] = 3 }				-- Will be the human player's COP, during Live Tuner runs?

end
Events.SequenceGameInitComplete.Add( PopulateLeaderStats )