-- CO Mission Enabler UI
-- Author: sman
-- DateCreated: 02/16/18 4:11:16 AM
--------------------------------------------------------------

MapModData.gT = MapModData.gT or {}
gT = MapModData.gT

local gT = MapModData.gT
local g_MissionList = gT.g_MissionList

YES = 1
NO = 0

ERA_ANCIENT_ID = GameInfoTypes.ERA_ANCIENT													-- Ancient Era type; careful: value is 0, don't use for table index!
ERA_CLASSICAL_ID = GameInfoTypes.ERA_CLASSICAL												-- Classical Era type
ERA_MEDIEVAL_ID = GameInfoTypes.ERA_MEDIEVAL												-- Medieval Era type
ERA_RENAISSANCE_ID = GameInfoTypes.ERA_RENAISSANCE											-- Renaissance Era type
ERA_INDUSTRIAL_ID = GameInfoTypes.ERA_INDUSTRIAL											-- Industrial Era type
ERA_MODERN_ID = GameInfoTypes.ERA_MODERN													-- Modern Era type
ERA_POSTMODERN_ID = GameInfoTypes.ERA_POSTMODERN											-- Atomic Era type
ERA_FUTURE_ID = GameInfoTypes.ERA_FUTURE													-- Info Era type

CONDUCT_RECON = 1
POISON_WATER = 2
SPREAD_RUMORS = 3
SABOTAGE_UNIT = 4
PILLAGE_IMPROVEMENT = 5
ASSASSINATE_GREAT_PERSON = 6
SABOTAGE_PRODUCTION = 7
STEAL_GOLD = 8
SPREAD_PLAGUE = 9
DESTROY_BUILDING = 10
RECRUIT_PARTISANS = 11
SPREAD_PROPAGANDA = 12
CAUSE_RESISTANCE = 13
CAUSE_ANARCHY = 14
NUKE_SUITCASE = 15
STEAL_CITY = 16
ABORT_MISSION = 17

ML_MISSION_NAME = 1
ML_ENABLED = 13

ENABLE_NOTIFICATIONS = 98


--include("00_Globals.lua")

ContextPtr:SetHide(true)


-------------------------------------------------------------------------------
function InputMEHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then        
		if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            ContextPtr:SetHide(true)
            return true
        end
    end
end
ContextPtr:SetInputHandler( InputMEHandler )
-------------------------------------------------------------------------------


function OnCOMEOK()																			-- Update enabled mission list, based on current status of COME popup
	ContextPtr:SetHide(true)																-- Hide popup
		
	for iDX = 1, #g_MissionList do															-- Default all missions to ENABLED in table
		g_MissionList[iDX][ML_ENABLED] = YES
	end

	--=================================================================================================================================
	--		Reset enable values in the table, based on the status of the CheckBoxes

	--if not Controls.COME_ConductRecon:IsChecked() then										-- Mission 1: Conduct Recon - Don't allow disabling "Conduct Recon" mission!
	--	g_MissionList[CONDUCT_RECON][ML_ENABLED] = NO											-- Disable mission if not checked
	--end


	if not Controls.COME_PoisonWells:IsChecked() then										-- Mission 2: Poison Wells
		g_MissionList[POISON_WATER][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_SpreadRumors:IsChecked() then										-- Mission 3: Spread Rumors
		g_MissionList[SPREAD_RUMORS][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_SabotageUnit:IsChecked() then										-- Mission 4: Sabotage Unit
		g_MissionList[SABOTAGE_UNIT][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_Pillage:IsChecked() then											-- Mission 5: Pillage Improvement
		g_MissionList[PILLAGE_IMPROVEMENT][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_AssassinateGP:IsChecked() then										-- Mission 6: Assassinate GP
		g_MissionList[ASSASSINATE_GREAT_PERSON][ML_ENABLED] = NO							-- Disable mission if not checked
	end

	if not Controls.COME_SabotageProduction:IsChecked() then								-- Mission 7: Sabotage Production
		g_MissionList[SABOTAGE_PRODUCTION][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_StealGold:IsChecked() then											-- Mission 8: Steal Gold
		g_MissionList[STEAL_GOLD][ML_ENABLED] = NO											-- Disable mission if not checked
	end

	if not Controls.COME_SpreadPlague:IsChecked() then										-- Mission 9: Spread Plague
		g_MissionList[SPREAD_PLAGUE][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_DestroyBuilding:IsChecked() then									-- Mission 10: Destroy Building
		g_MissionList[DESTROY_BUILDING][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_RecruitPartisans:IsChecked() then									-- Mission 11: Recruit Partisans
		g_MissionList[RECRUIT_PARTISANS][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_SpreadPropaganda:IsChecked() then									-- Mission 12: Spread Propaganda
		g_MissionList[SPREAD_PROPAGANDA][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_CauseResistance:IsChecked() then									-- Mission 13: Cause Resistance
		g_MissionList[CAUSE_RESISTANCE][ML_ENABLED] = NO									-- Disable mission if not checked
	end

	if not Controls.COME_CreateAnarchy:IsChecked() then										-- Mission 14: Create Anarchy
		g_MissionList[CAUSE_ANARCHY][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_NuclearSuitcase:IsChecked() then									-- Mission 15: Nuclear Suitcase
		g_MissionList[NUKE_SUITCASE][ML_ENABLED] = NO										-- Disable mission if not checked
	end

	if not Controls.COME_StealCity:IsChecked() then											-- Mission 16: Steal City
		g_MissionList[STEAL_CITY][ML_ENABLED] = NO											-- Disable mission if not checked
	end


	if not Controls.COME_EnableNotifications:IsChecked() then								-- Enable Notifications?
		g_MissionList[ENABLE_NOTIFICATIONS][ML_ENABLED] = NO	
	else
		--g_bNotifyIfCovertOpPossible = true													-- Enable Notifications if checked (just to be sure...)
		g_MissionList[ENABLE_NOTIFICATIONS][ML_ENABLED] = YES
	end

	PrintMissionStatus()																	-- TEMP - display current mission status list

end
Controls.COME_OK:RegisterCallback(Mouse.eLClick, OnCOMEOK)


function COMEDiploCornerPopup()
	ContextPtr:SetHide(false)
end


function COMEUpdateAdditionInformationMenu(additionalEntries)
	table.insert(additionalEntries, {
		text=Locale.ConvertTextKey("TXT_KEY_COVERT_OPS_COME_TITLE"), 
		call=COMEDiploCornerPopup
	})
end
LuaEvents.AdditionalInformationDropdownGatherEntries.Add( COMEUpdateAdditionInformationMenu )
LuaEvents.RequestRefreshAdditionalInformationDropdownEntries()



function PrintMissionStatus()
	for iDX = 1, #g_MissionList do															-- Default all missions to ENABLED in table
		local sStatus = "Enabled"
		if g_MissionList[iDX][ML_ENABLED] == NO then sStatus = "Disabled" end
		print("Mission " .. iDX .. " (" .. g_MissionList[iDX][ML_MISSION_NAME] .. "):    Status: " .. sStatus)
	end

	if g_MissionList[ENABLE_NOTIFICATIONS][ML_ENABLED] == YES then
		print("Notifications Enabled")
	else
		print("Notifications Disabled")
	end
end

